const app = getApp()

import Dialog from '@vant/weapp/dialog/dialog';
import Notify from '@vant/weapp/notify/notify';

import {
    selfFormatTimeYMD,
    selfFormatTimeHM,
    checkIsImg
} from "../../../../utils/util.js"


import {
    dispatcherListRq
} from "../../../../api/repair/distributionCase.js"


Page({

    /**
     * 页面的初始数据
     */
    data: {
        IMG_NAME: app.IMG_NAME,
        userData: null,
        dataChange: false,
        tabTitle: '待派单', // tab 标题
        resendOrderVisible: false, // 重新派单显示
        // 重新派单
        resendOrderPageNum: 1,
        resendOrderPageSize: 10,
        resendOrderStatus: 0,
        resendOrderDataList: [],
        resendOrderIsDataAll: false,
        // 待派单
        pendingOrderPageNum: 1,
        pendingOrderPageSize: 10,
        pendingOrderStatus: 1,
        pendingOrderDataList: [],
        pendingOrderIsDataAll: false,
        // 已派单
        assignOrderPageNum: 1,
        assignOrderPageSize: 10,
        assignOrderStatus: 2,
        assignOrderDataList: [],
        assignOrderIsDataAll: false,
        // 已关闭
        closeOrderPageNum: 1,
        closeOrderPageSize: 10,
        closeOrderStatus: 3,
        closeOrderDataList: [],
        closeOrderIsDataAll: false,
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let _this = this;
        _this.setData({
            userData: wx.getStorageSync('user'),
        })
        // 获取数据
        let userId = _this.data.userData.id
        // 角色是否是：网格长
        if (true) {
            _this.setData({
                tabTitle: '重新派单', // tab 标题
                resendOrderVisible: true, // 重新派单显示
            })
            _this.getDataList('重新派单')
        }
        // 数据
        _this.getDataList('待派单')
        _this.getDataList('已派单')
        _this.getDataList('已关闭')
    },

    // 获取数据
    getDataList(transferTabTitle) {
        // 获取参数
        let _this = this;
        let tabTitle = _this.data.tabTitle
        if (transferTabTitle) {
            tabTitle = transferTabTitle
        }
        let userId = _this.data.userData.id
        let isDataAll = null
        let pageNum = null
        let pageSize = null
        let status = null

        if (tabTitle == '重新派单') {
            pageNum = _this.data.resendOrderPageNum
            pageSize = _this.data.resendOrderPageSize
            status = _this.data.resendOrderStatus
            isDataAll = _this.data.resendOrderIsDataAll

        } else if (tabTitle == '待派单') {
            pageNum = _this.data.pendingOrderPageNum
            pageSize = _this.data.pendingOrderPageSize
            status = _this.data.pendingOrderStatus
            isDataAll = _this.data.pendingOrderIsDataAll

        } else if (tabTitle == '已派单') {
            pageNum = _this.data.assignOrderPageNum
            pageSize = _this.data.assignOrderPageSize
            status = _this.data.assignOrderStatus
            isDataAll = _this.data.assignOrderIsDataAll

        } else if (tabTitle == '已关闭') {
            pageNum = _this.data.closeOrderPageNum
            pageSize = _this.data.closeOrderPageSize
            status = _this.data.closeOrderStatus
            isDataAll = _this.data.closeOrderIsDataAll

        } else {
            wx.showToast({
                title: `tab 切换错误(${tabTitle})`,
                icon: 'none',
            });
            return;
        }

        // 判断数据是否已全部加载
        if (isDataAll) {
            return;
        }
        // 传递参数
        let param = {
            userId,
            pageNum,
            pageSize,
            statusValue: status
        }
        // 查询数据        
        dispatcherListRq(param).then(res => {
            console.log('dispatcherListRq', res);
            let dataList = res.data.records
            let isDataAll = false
            if (!(dataList && dataList.length > 0)) {
                dataList = []
                isDataAll = true
            }
            //
            if (tabTitle == '重新派单') {
                _this.setData({
                    resendOrderDataList: _this.data.resendOrderDataList.concat(_this.formartData(dataList)),
                    resendOrderPageNum: pageNum + 1,
                    resendOrderIsDataAll: isDataAll,
                })

            } else if (tabTitle == '待派单') {
                _this.setData({
                    pendingOrderDataList: _this.data.pendingOrderDataList.concat(_this.formartData(dataList)),
                    pendingOrderPageNum: pageNum + 1,
                    pendingOrderIsDataAll: isDataAll,
                })

            } else if (tabTitle == '已派单') {
                _this.setData({
                    assignOrderDataList: _this.data.assignOrderDataList.concat(_this.formartData(dataList)),
                    assignOrderPageNum: pageNum + 1,
                    assignOrderIsDataAll: isDataAll,
                })

            } else if (tabTitle == '已关闭') {
                _this.setData({
                    closeOrderDataList: _this.data.closeOrderDataList.concat(_this.formartData(dataList)),
                    closeOrderPageNum: pageNum + 1,
                    closeOrderIsDataAll: isDataAll,
                })
            }
        })
    },

    // 格式化数据
    formartData(dataList) {
        // 格式化数据
        return dataList.map(item => {
            let repairImages = item.repairImages
            if (repairImages) {
                let fileList = JSON.parse(repairImages)
                let file = fileList.find(item => checkIsImg(item.url))
                if (file) {
                    item.visibleImg = file.url
                } else {
                    item.visibleImg = '/profile/static/repair/index/noneImg.png'
                }
            } else {
                item.visibleImg = '/profile/static/repair/index/noneImg.png'
            }
            return item;
        })
    },

    // tab 点击切换
    tabClickSwitch(event) {
        console.log('tabClickSwitch', event);
        let _this = this;
        _this.setData({
            tabTitle: event.detail.title
        })
    },

    // 跳转-详情
    jumpDetail(e) {
        console.log('detail', e);
        let id = e.currentTarget.dataset.obj.id
        wx.navigateTo({
            url: '/pages/reportRepair/assign/detail/detail?id=' + id,
        })
    },

    // 跳转-重新分配
    jumpAgain() {
        wx.navigateTo({
            url: '/pages/reportRepair/assign/again/again',
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        let _this = this;

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {
        console.log('onPullDownRefresh', '页面相关事件处理函数--监听用户下拉动作');

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {
        console.log('onReachBottom', '页面上拉触底事件的处理函数');
        let _this = this;
        // 获取数据
        _this.getDataList()
    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage(e) {
        console.log('onShareAppMessage', e);
        let _this = this;
        let id = e.target.dataset.id;
        let detail = _this.data.reservationDataList.find(item => item.id == id)
        //
        let param = {
            title: detail.title,
            path: "/pages/meeting/invite/invite?id=" + id,
            imageUrl: app.IMG_NAME + detail.roomContent.indoorPicUrlFirst,
        }
        console.log('onShareAppMessage', param);
        return param;
    }
})